﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using SimpleBlog.Controllers;
using System.Web.Mvc;
using SimpleBlog.Code;
using SimpleBlog.Models;

namespace SimpleBlog.UnitTests
{
    [TestClass]
    public class PostControllerTester
    {
        [TestMethod]
        [ExpectedException(typeof(NotImplementedException))]
        public void Index_Should_Return_NotImplemented_Exception()
        {
            PostController myPostController = new PostController();
            var result = myPostController.Index();
            Assert.Fail("Index did not throw an exception.");
        }

        [TestMethod]
        public void Create_Returns_Null_For_Anonymous_User()
        {
            PostController myPostController = new PostController();
            ViewResult result = (ViewResult)myPostController.Create();
            Assert.IsNull(result.View);
        }

        [TestMethod]
        public void Details_Returns_Details_View_For_Valid_Post()
        {
            //var myPostController = new PostController();
            var myPostController = new PostController(new TestPostRepository());
            var result = myPostController.Details(2009, 1, 1, "foo");
            Assert.IsTrue(result is ViewResult);
            ViewResult myResult = result as ViewResult;
            Assert.IsTrue(myResult.ViewData.Model is Post);
            Post p = myResult.ViewData.Model as Post;
            Assert.AreEqual("foo", p.EncodedTitle);
        }

        private class TestPostRepository : IPostRepository
        {
            #region IPostRepository Members

            public SimpleBlog.Models.Post Get(int year, int month, int day, string friendlyTitle)
            {
                if(friendlyTitle == "foo")
                {
                    var post = new Post();
                    post.DatePosted = new DateTime(year, month, day);
                    post.Title = friendlyTitle;
                    post.EncodedTitle = Utility.BuildFriendlyUrl(friendlyTitle);
                    return post;
                    }
                return null;
            }

            #endregion
        }


    }
}
