﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;

using System.Security;
using System.Security.Permissions;
using System.Web.Routing;
using SimpleBlog.Code;
using SimpleBlog.Models;
using SimpleBlog.Filters;

namespace SimpleBlog.Controllers
{
    public class PostController : Controller
    {
        #region Constructor
        private IPostRepository _postRepository;
        public PostController() : this(new SqlPostRepository())
        {
        }

        public PostController(IPostRepository postRepository)
        {
            _postRepository = postRepository;
        }
        #endregion

        public ActionResult Index()
        {
            // Add action logic here
            throw new NotImplementedException();
        }

        //[PrincipalPermission(SecurityAction.Demand, Authenticated = true)]
        [RequiresAuthenticationFilter]
        public ActionResult Create()
        {
            return View();
        }

        public ActionResult Details(int year, int month, int day, string friendlyTitle)
        {
            // dependency!
            //BlogDataContext db = new BlogDataContext();

            //var post = db.Posts.Single(p => p.EncodedTitle == friendlyTitle
            //    && p.DatePosted.Year == year
            //    && p.DatePosted.Month == month
            //    && p.DatePosted.Day == day);

            #region DI
            var post = this._postRepository.Get(year, month, day, friendlyTitle);
            #endregion

            return View(post);
        }

        public ActionResult Insert(string title, string contents, string category)
        {
            Post newPost = new Post();
            newPost.DatePosted = DateTime.Now;
            newPost.Title = title;
            newPost.EncodedTitle = Utility.BuildFriendlyUrl(title);
            newPost.Contents = contents;
            newPost.Abstract = Utility.GetAbstract(contents);
            newPost.Category = category;

            BlogDataContext db = new BlogDataContext();
            db.Posts.InsertOnSubmit(newPost);
            db.SubmitChanges();

            return RedirectToAction("Index", "Home");
        }

    }
}
